#include  <stdio.h>
#include  <string.h>

#include  "types.h"
#include  "plateform.h"
#include  "z80.h"
#include  "vga.h"
#include  "ppi.h"
#include  "upd.h"
#ifdef USE_MULTIFACE
#include  "multiface.h"
#endif
#include  "AY8912.h"
#include  "Sound.h"
#include  "Config.h"
#include  "crtc.h"
#ifdef USE_LOG
#include  "log.h"
#endif
#ifdef USE_PRINTER
#include  "Printer.h"
#endif
#ifdef USE_DEBUG
#include  "desasm.h"
#endif
#include "viddef.h"

/********************************************************* !NAME! **************
* Nom : Turbo
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Mode turbo activ/dsactiv
*
********************************************************** !0! ****************/
int Turbo = 0;

/********************************************************* !NAME! **************
* Nom : DebugMode
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Mode debug activ/dsactiv
*
********************************************************** !0! ****************/
#ifdef USE_DEBUG
int DebugMode = 0;
#endif

//
// Constante de temps avant lecture/criture cassette.
// Cette constante contient le nombre de cycles Z80  attentre
// avant appel des fonctions.
// ATTENTION : la modification de cette constante entraine un
// changement de frquence de lecture/criture des fichiers cassettes
// et peut donc causer une incompatibilit avec des fichiers de versions
// prcdentes.
//
#define     TPS_TAPE        0x180


/********************************************************* !NAME! **************
* Nom : finMain
********************************************************** !PATHS! *************
* !./V1!\\!./V2!\\!./V3!\\!./V4!\\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\\/FLE!, ligne : !./LN!
*
* Description : Fin du programme
*
********************************************************** !0! ****************/
int finMain = 0;

/********************************************************* !NAME! **************
* Nom : CntHSync
********************************************************** !PATHS! *************
* !./V1!\\!./V2!\\!./V3!\\!./V4!\\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\\/FLE!, ligne : !./LN!
*
* Description : Compteur position horizontale raster
*
********************************************************** !0! ****************/
int CntHSync = 0;

/********************************************************* !NAME! **************
* Nom : MemBitmap
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Buffer contenant l'image de l'cran du CPC
*
********************************************************** !0! ****************/
//static UBYTE *MemBitmap;

viddef_t  vid;

/********************************************************* !NAME! **************
* Nom : AffichePiste
********************************************************** !PATHS! *************
* !./V1!\\!./V2!\\!./V3!\\!./V4!\\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\\/FLE!, ligne : !./LN!
*
* Description : Affichage du numro de piste en cours (disquette)
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
static void AffichePiste( int * OldTrack, int CurrTrack )
{
/*    static char Msg[ 16 ];
    
    if ( CurrTrack != * OldTrack )
        {
        sprintf( Msg, "Piste:%02d", CurrTrack );
        TextOut( DeviceContext, 612, 544, Msg, strlen( Msg ) );
        * OldTrack = CurrTrack;
        }
*/
}

/********************************************************* !NAME! **************
* Nom : TabPoints
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Conversions pixels CPC -> cran PC
*
********************************************************** !0! ****************/
static unsigned char TabPoints[ 4 ][ 256 ][ 8 ];

/********************************************************* !NAME! **************
* Nom : CalcPoints
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Calcule l'image des points  afficher  l'cran en fonction du
*               mode d'affichage du CPC (mode 0, 1 ou 2)
*
* Rsultat    : /
*
* Variables globales modifies : TabPoints
*
********************************************************** !0! ****************/
static void CalcPoints( void )
{
    int a, b, c, d, i;

    // Pour le mode 0
    for ( i = 0; i < 256; i++ )
        {
        a = ( i >> 7 )
          + ( ( i & 0x20 ) >> 3 )
          + ( ( i & 0x08 ) >> 2 )
          + ( ( i & 0x02 ) << 2 );
        b = ( ( i & 0x40 ) >> 6 )
          + ( ( i & 0x10 ) >> 2 )
          + ( ( i & 0x04 ) >> 1 )
          + ( ( i & 0x01 ) << 3 );
        TabPoints[ 0 ][ i ][ 0 ] = ( char )a;
        TabPoints[ 0 ][ i ][ 1 ] = ( char )a;
        TabPoints[ 0 ][ i ][ 2 ] = ( char )a;
        TabPoints[ 0 ][ i ][ 3 ] = ( char )a;
        TabPoints[ 0 ][ i ][ 4 ] = ( char )b;
        TabPoints[ 0 ][ i ][ 5 ] = ( char )b;
        TabPoints[ 0 ][ i ][ 6 ] = ( char )b;
        TabPoints[ 0 ][ i ][ 7 ] = ( char )b;
        }

    // Pour le mode 1
    for ( i = 0; i < 256; i++ )
        {
        a = ( i >> 7 ) + ( ( i & 0x08 ) >> 2 );
        b = ( ( i & 0x40 ) >> 6 ) + ( ( i & 0x04 ) >> 1 );
        c = ( ( i & 0x20 ) >> 5 ) + ( i & 0x02 );
        d = ( ( i & 0x10 ) >> 4 ) + ( ( i & 0x01 ) << 1 );
        TabPoints[ 1 ][ i ][ 0 ] = ( char )a;
        TabPoints[ 1 ][ i ][ 1 ] = ( char )a;
        TabPoints[ 1 ][ i ][ 2 ] = ( char )b;
        TabPoints[ 1 ][ i ][ 3 ] = ( char )b;
        TabPoints[ 1 ][ i ][ 4 ] = ( char )c;
        TabPoints[ 1 ][ i ][ 5 ] = ( char )c;
        TabPoints[ 1 ][ i ][ 6 ] = ( char )d;
        TabPoints[ 1 ][ i ][ 7 ] = ( char )d;
        }

    // Pour le mode 2
    for ( i = 0; i < 256; i++ )
        {
        TabPoints[ 2 ][ i ][ 0 ] = ( char )( i >> 7 );
        TabPoints[ 2 ][ i ][ 1 ] = ( char )( ( i & 0x40 ) >> 6 );
        TabPoints[ 2 ][ i ][ 2 ] = ( char )( ( i & 0x20 ) >> 5 );
        TabPoints[ 2 ][ i ][ 3 ] = ( char )( ( i & 0x10 ) >> 4 );
        TabPoints[ 2 ][ i ][ 4 ] = ( char )( ( i & 0x08 ) >> 3 );
        TabPoints[ 2 ][ i ][ 5 ] = ( char )( ( i & 0x04 ) >> 2 );
        TabPoints[ 2 ][ i ][ 6 ] = ( char )( ( i & 0x02 ) >> 1 );
        TabPoints[ 2 ][ i ][ 7 ] = ( char )( i & 0x01 );
        }

    // Mode 3 = Mode 0 ???
    for ( i = 0; i < 256; i++ )
        for ( a = 0; a < 8; a++ )
            TabPoints[ 3 ][ i ][ a ] = TabPoints[ 0 ][ i ][ a ];
}

/********************************************************* !NAME! **************
* Nom : InitPlateforme
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Initialisation diverses
*
* Rsultat    : /
*
* Variables globales modifies : JoyKey, clav
*
********************************************************** !0! ****************/
void InitPlateforme( void )
{
    int i;

    CalcPoints();
/*    for ( i = 0; i < 256; i++ )
        {
        JoyKey[ i ].Port = 0xFF;
        JoyKey[ i ].Ligne = 0x0F;
        }
    JoyKey[ JoyUp ].Port       = 0xFE;
    JoyKey[ JoyUp ].Ligne      = 0x09;
    JoyKey[ JoyDown ].Port     = 0xFD;
    JoyKey[ JoyDown ].Ligne    = 0x09;
    JoyKey[ JoyLeft ].Port     = 0xFB;
    JoyKey[ JoyLeft ].Ligne    = 0x09;
    JoyKey[ JoyRight ].Port    = 0xF7;
    JoyKey[ JoyRight ].Ligne   = 0x09;
    JoyKey[ JoyFire1 ].Port    = 0xEF;
    JoyKey[ JoyFire1 ].Ligne   = 0x09;
    JoyKey[ JoyFire2 ].Port    = 0xDF;
    JoyKey[ JoyFire2 ].Ligne   = 0x09;
    memset( clav, 0xFF, sizeof( clav ) );
    if ( ! SmallScreen )
        CopyRight();*/
}

/********************************************************* !NAME! **************
* Nom : TraceLigne8B320
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Trace une ligne cran de 320 points en couleurs 8 bits
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
void TraceLigne8B320( int y )
{
    int x, adr = y * 80;

    //UBYTE * p = ( UBYTE * )MemBitmap;
	UBYTE * p = vid.buffer;
    p += adr << 2;
    for ( x = 0; x < 80; x++, adr++ )
        {
        int adCrtc = TabAdrCrtc[ adr ];
        if ( adCrtc != 0xFFFF )
            {
            unsigned char * ad = TabPoints[ lastMode ][ MemCPC[ adCrtc + OfsEcr ] ];

			* p++ = ( UBYTE )TabCoul[ ad[ 0 ] ];
            * p++ = ( UBYTE )TabCoul[ ad[ 2 ] ];
            * p++ = ( UBYTE )TabCoul[ ad[ 4 ] ];
            * p++ = ( UBYTE )TabCoul[ ad[ 6 ] ];
            }
        else
            {
            memset( p, TabCoul[ 16 ], 4 );
            p += 4;
            }
        }
}

void Erreur( char * Msg )
{
	fprintf (stderr, "Error: %s", Msg);
    exit(-1);	
}

void UpdateScreen( void );
void gniPlaySound();

unsigned long GetTickCount();
void Sleep(long time);
static void Go( void )
{
    int DebutVSync = 0, NbLignesMax = 312, CntVSync = 0;
    int TailleChar, TpsVbl = 0;
    int SyncCount = 0;
    unsigned long TimeOut, Time, OldTime = 0;
    int FrameCnt = 0;
    int OldTrack = -1;
#ifdef USE_DEBUG
    int Step = 0;
#endif
#ifdef USE_TAPE
    int OldCptInstr = 0, CntTape = 0;
#endif

    //
    // Boucle principale...
    //
    do
        {
#ifdef USE_DEBUG
        if ( DebugMode )
            {
            if ( ! Step )
                {
                Debug( DeviceContext );
                Step = 1;
                }
            //if ( PeekMessage( &msg, NULL, 0,0, PM_REMOVE ) )
            //    DispatchMessage( &msg );

            if ( Cont )
                {
                ExecInstZ80();
                Step = 0;
                Cont = 0;
                }
            }
        else
#endif
            ExecInstZ80();

#ifdef USE_TAPE
        //
        // Extraction des bits pour E/S cassette tous les 1/TPS_TAPE cycles cpu
        //
        CntTape += ( CptInstr - OldCptInstr );
        if ( CptInstr < OldCptInstr )
            CntTape += CycleLigne;

        OldCptInstr = CptInstr;
        if ( CntTape >= TPS_TAPE )
            {
            WriteCas();
            ReadCas();
            CntTape -= TPS_TAPE;
            }
#endif
        //
        // Gestion des compteurs : cycles d'horloges, VSync et HSync du CRTC
        //
        if ( CptInstr >= CycleLigne ) // Nbre de cycles = temps d'une ligne
            {
            //
            // Trace une ligne
            //
            CptInstr -= CycleLigne;
            if ( CntVSync < 266 )
                TraceLigne8B320( CntVSync );

            CntHSync++;
            CntVSync++;
            if ( ! SyncCount )
                {
                //
                // Si 52 lignes compte -> Gnration d'une interruption
                //
                if ( CntHSync == 52 )
                    {
                    //if ( PeekMessage( &msg, NULL, 0,0, PM_REMOVE ) )
                    //    DispatchMessage( &msg );

                    if ( ! SmallScreen )
                        AffichePiste( &OldTrack, GetCurrTrack() );
#ifdef USE_DEBUG
                    if ( ! DebugMode )
#endif
                        IRQ = 1;

                    CntHSync = 0;
                    }
                }
            else
                {
                SyncCount--;
                if ( ! SyncCount )
                    {
                    if ( CntHSync > 32 )
                        IRQ = 1;

                    CntHSync = 0;
                    }
                }

#ifdef USE_SOUND
			if (Sound)
				gniPlaySound();
#endif
            //
            // Arriv en fin d'cran -> Raz de VSync
            //
            if ( CntVSync >= NbLignesMax )
                {
                SyncCount = 2;
                TimeOut = ( 1000000 / ( FreqLigne / NbLignesMax ) ) - 1;
				//TimeOut/=2;	// MR Test
#ifdef USE_SOUND
                if ( Sound )
                    Loop8912( TimeOut );
#endif
                //
                // Prise en compte des registres du format vertical du CRTC
                //
                TailleChar = RegsCRTC[ 9 ] + 1;
                CntVSync = 0;
                NbLignesMax = /*RegsCRTC[ 5 ] + */( ( 1 + RegsCRTC[ 4 ] ) * TailleChar );
                DebutVSync = RegsCRTC[ 7 ] * TailleChar; /* #### */
                //
                // Rafraichissement de l'cran...
                //
                if ( FrameCnt++ > FrameSkip )
                {
                    FrameCnt = 0;
                    UpdateScreen();
                }

#if 1
                //
                // Synchronisation de l'image  50 Hz
                //
                if ( ! Turbo )
                {
#if 1
                    do
                    {
                        //Time = GetTickCount() * 1000;
						Time = GetTickCount();	// micro instead of milli
                        //Sleep( Time - OldTime < 2 ? 1000 : 0 );	// sleep in microseconds
                    }
                    while( Time - OldTime < TimeOut );
                    OldTime = Time;
#else
					Time = GetTickCount();
					Sleep(TimeOut+OldTime-Time);
					OldTime=GetTickCount();
#endif	//0
				}
#endif	// 0
			}
            //
            // Si Compteur VSync = Position d'envoi du VBL...
            //
            if ( CntVSync == DebutVSync )
                TpsVbl = 0;

            //
            // Gnration du "Vertical Blanking Line"
            //
            VBL = ( TpsVbl++ < 32 );
		}
	}
    while( ! finMain );
}

void CPCMain(void)
{
	char * Msg;

    if ( ReadConfig() )
    {
#ifdef USE_LOG
		if ( StartLog( "Z80.LOG" ) )
		{
#endif
			if ( InitMemCPC() )
			{
#ifdef USE_MULTIFACE
				if ( ! Multiface || InitMultiface() )
#endif
				{
#ifdef USE_PRINTER
					StartPrinter( "print.txt" );
#endif
					InitPlateforme();
					ResetZ80();
					ResetUPD();
#ifdef USE_SOUND
					InitSound();	// MR sound on/off in menu
					if ( Sound )
					{
						//InitSound();	// MR sound on/off in menu
						Reset8912();
					}
#endif
					Go();
					EjectDiskUPD();
#ifdef USE_TAPE
					CloseTap();
#endif
#ifdef USE_SOUND
					//if ( Sound )
					//	EndSound();
#endif
#ifdef USE_PRINTER
					EndPrinter();
#endif
				}
#ifdef USE_MULTIFACE
				else
				{
					Msg = "Rom multiface non trouve";
#ifdef USE_LOG
					Log( Msg, LOG_WARNING );
#endif
					Erreur( Msg );
				}
#endif
			}
			else
			{
				Msg = "Roms du CPC non trouves";
#ifdef USE_LOG
				Log( Msg, LOG_WARNING );
#endif
				Erreur( Msg );
			}

#ifdef USE_LOG
			EndLog();
		}
		else
			Erreur( "Impossible d'ouvrir le fichier de trace" );
#endif
	}
	else
		Erreur( "Fichier de configuration du CPC non trouv." );

}
