/*******************************************************************
 *
 *	File:		App.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2001, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __APP_H
#define __APP_H

#include <coecntrl.h>
#include <coeccntx.h>
#include <coemain.h>

// MR
//#include <eikappui.h>
//#include <eikapp.h>
#include <aknappui.h>
#include <aknapp.h>
#include <eikdoc.h>

#include "Engine.h"
#include "S60cpc.hrh"

const TUid KUidS60cpcApp = { 0x00DCF006 };

class CWsBitmap;
class CGameRunningDialog;

class CS60cpcDocument : public CEikDocument
{
public:
	~CS60cpcDocument();
	CS60cpcDocument(CEikApplication& aApp);
	void ConstructL();

private: // from CEikDocument
	CEikAppUi* CreateAppUiL();
};


class CS60cpcAppView : public CCoeControl, public MCoeControlBrushContext
{
public:
	~CS60cpcAppView();
	void ConstructL(const TRect& aRect);
private:
	void Draw(const TRect& /*aRect*/) const;

	CWsBitmap*	iBgImage;
	TPoint		iImagePosition;
};


//class CS60cpcAppUi : public CEikAppUi, public MGameWatcher
class CS60cpcAppUi : public CAknAppUi, public MGameWatcher
{
public:
	CS60cpcAppUi(){}
	void ConstructL();
	~CS60cpcAppUi();

public:			// implements MGameWatcher
	void NotifyGameFinished();


protected: // from CEikAppUi
	void HandleCommandL(TInt aCommand);
	TKeyResponse HandleKeyEventL(const TKeyEvent& aKeyEvent,TEventCode aType);

protected:		// new stuf
	void DisplayAboutDialogL();
	void DisplayControlsHelpDialogL();
	void DisplayControlsWadFilesDialogL();
	void DisplayAudioRateL();

	void StopGame();
	void RunGameL();
	CGameRunner*			iGameRunner;

private:
	CS60cpcAppView* iAppView;
};



//class CS60cpcApplication : public CEikApplication
class CS60cpcApplication : public CAknApplication
	{
private: // from CApaApplication
	CApaDocument* CreateDocumentL();
	TUid AppDllUid() const;
	};

#endif
