/*******************************************************************
 *
 *	File:		Audio.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2001, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __AUDIO_H
#define __AUDIO_H

#include <Mda\Client\Resource.h>
#include <Mda\Client\Utility.h>
#include <Mda\Common\Audio.h>
#include <MdaAudioOutputStream.h>

#include <e32base.h>
#include <w32std.h>


const TInt KSoundBuffers = 10;
const TInt KBufferedFrames = 1;

class CGameAudio : public CBase, public MMdaAudioOutputStreamCallback
{
public:
	static CGameAudio* NewL(TBool aStereo, TInt aPcmFrames);
	~CGameAudio();
	void Destruct();
	TInt Write(TInt16* aBuffer, TInt aSize);
	void PlaySound();

protected:
	CGameAudio(TBool aStereo, TInt aPcmFrames);
	void ConstructL();
	TBool	iStereo;
protected:
	virtual void MaoscOpenComplete(TInt aError);
	virtual void MaoscBufferCopied(TInt aError, const TDesC8& aBuffer);
	virtual void MaoscPlayComplete(TInt aError);

	CMdaAudioOutputStream	*iMdaAudioOutputStream;
	TMdaAudioDataSettings	iMdaAudioDataSettings;

	TBool					iIsOpen;
	TBool					iHasCopied;
	void					WaitForOpenToCompleteL();
	void					WaitForCopyToCompleteL();

	HBufC8*					iSoundBuffers[KSoundBuffers];
	TInt16*					iCurrentPosition;
	TInt					iCurrentBuffer;
	TInt					iFrameCount;
	TInt					iPcmFrames;
};


#endif			/* __AUDIO_H */
