#define _CPP

#include  "types.h"

#ifdef USE_SOUND

#include "config.h"
#include "audio.h"
#include "polledas.h"

#include <f32file.h>
#include <e32svr.h>
#include <string.h>

#include <stdio.h>

extern int iSoundSampleRate;

//#define SND_RATE            22050
int SND_RATE = 22050;
#define SND_CHANNELS        6
#define SND_BUFSIZE         512				// WINS : 2048 c mieux
#define SND_BUFFERS         KSoundBuffers	// c t 6
#define SND_VOLUME          50

/********************************************************* !NAME! **************
* Nom : NoiseGen
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Gnrateur de bruit alatoire
*
********************************************************** !0! ****************/
static int NoiseGen;


/********************************************************* !NAME! **************
* Nom : Exit
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Fin demande
*
********************************************************** !0! ****************/
static int Exit;


/********************************************************* !NAME! **************
* Nom : hWave
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Structure HWAVEOUT pour gnration des sons
*
********************************************************** !0! ****************/
//static HWAVEOUT hWave = 0;


/********************************************************* !NAME! **************
* Nom : Buf
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Buffer de cration des chantillons sonores par canal
*
********************************************************** !0! ****************/
//static UBYTE Buf[ SND_BUFFERS ][ SND_BUFSIZE ];
//static USHORT Buf[ SND_BUFFERS ][ SND_BUFSIZE ];
//static TInt16 Buf[ SND_BUFFERS ][ SND_BUFSIZE ];


/********************************************************* !NAME! **************
* Nom : Header
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Structure WAVEHDR pour gnration des sons
*
********************************************************** !0! ****************/
//static WAVEHDR Header[ SND_BUFFERS ];


/********************************************************* !NAME! **************
* Nom : Wave
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Buffer de cration des chantillons sonores tout canaux
*
********************************************************** !0! ****************/
static int Wave/*[ SND_BUFFERS ]*/[ SND_BUFSIZE ];


/********************************************************* !NAME! **************
* Nom : TabChannel
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Canaux sonores
*
********************************************************** !0! ****************/
static struct
{
    int Freq;
    int Volume;
    int Count;
} TabChannel[ SND_CHANNELS ];

extern "C"
{
	void SetSound( int Channel, int Freq, int Volume );
	BOOL InitSound();
	void gniPlaySound();
}

CPolledActiveScheduler*		sTheScheduler;
CGameAudio* sGameAudio= NULL;

/*******************************************
 *
 * CGameAudio
 *
 *******************************************/

CGameAudio::CGameAudio(TBool aStereo, TInt aPcmFrames) : iStereo(aStereo), iPcmFrames(aPcmFrames)
{
}


CGameAudio* CGameAudio::NewL(TBool aStereo, TInt aPcmFrames)
{
	CGameAudio*		self = new(ELeave) CGameAudio(aStereo, aPcmFrames);
	CleanupStack::PushL(self);
	self->ConstructL();
	CleanupStack::Pop();		// self
	return self;
}


CGameAudio::~CGameAudio()
{
	Destruct();
}

void CGameAudio::Destruct()
{
	delete iMdaAudioOutputStream;
	iMdaAudioOutputStream = NULL;

	for (TInt i=0 ; i<KSoundBuffers ; i++)
		delete iSoundBuffers[i];
}


void CGameAudio::ConstructL()
{
	CMdaServer* server = CMdaServer::NewL();

	iMdaAudioOutputStream = CMdaAudioOutputStream::NewL(*this, server);
	iMdaAudioOutputStream->Open(&iMdaAudioDataSettings);//callback calls QueueIdle function

	WaitForOpenToCompleteL();
#if 0
	TInt r;

	TRAP(r,iMdaAudioOutputStream->SetAudioPropertiesL(TMdaAudioDataSettings::ESampleRate44100Hz, iStereo ? TMdaAudioDataSettings::EChannelsStereo : TMdaAudioDataSettings::EChannelsMono));
	if (r!=0)
		printf("prout");
	iMdaAudioOutputStream->SetVolume(iMdaAudioOutputStream->MaxVolume());        
	iMdaAudioOutputStream->SetPriority(EPriorityMuchMore, EMdaPriorityPreferenceNone);	// a voir...

	TInt	bytesPerFrame = iStereo ? iPcmFrames << 2 : iPcmFrames << 1;
	for (TInt i=0 ; i<KSoundBuffers ; i++)
	{
		iSoundBuffers[i] = HBufC8::NewL(bytesPerFrame * KBufferedFrames);
		iSoundBuffers[i]->Des().SetLength(bytesPerFrame * KBufferedFrames);
	}

	iFrameCount = 0;
	iCurrentBuffer = 0;
	iCurrentPosition = (TInt16*) iSoundBuffers[iCurrentBuffer]->Ptr();

	// ------------------------------------------------------
	//memset( iCurrentPosition, 16384, SND_BUFSIZE*2 );
	for (i=0;i<SND_BUFSIZE;i++)
		iCurrentPosition[i]=16384;

	//sTheScheduler->Schedule();
	TRAP(r,iMdaAudioOutputStream->WriteL(*iSoundBuffers[iCurrentBuffer]));
	if (r!=0)
		printf("prout");
	//User::After(0);

	if (++iCurrentBuffer == KSoundBuffers)
		iCurrentBuffer = 0;
	iCurrentPosition = (TInt16*) iSoundBuffers[iCurrentBuffer]->Ptr();
#endif	// 0
}

TInt CGameAudio::Write(TInt16* aBuffer, TInt aSize)
{
	TInt	byteSize = iStereo ? aSize << 2 : aSize << 1;
	//Mem::Copy(iCurrentPosition, aBuffer, byteSize);
	//iCurrentPosition += aSize;

	//if (++iFrameCount == KBufferedFrames)
	{
		iHasCopied = EFalse;
		TInt r;
		sTheScheduler->Schedule();
		iMdaAudioOutputStream->WriteL(*iSoundBuffers[iCurrentBuffer]);
		//User::After(0);
		//WaitForCopyToCompleteL();

		iFrameCount = 0;
		if (++iCurrentBuffer == KSoundBuffers)
			iCurrentBuffer = 0;
		iCurrentPosition = (TInt16*) iSoundBuffers[iCurrentBuffer]->Ptr();
	}
	return aSize;
}

//static int min=10000,max=-10000;
void CGameAudio::PlaySound()
{
    int i, j, k, l, n, v;

    for ( j = 0; j < SND_CHANNELS; j++ )
    {
        v = TabChannel[ j ].Volume;
        if ( TabChannel[ j ].Freq && v )
            if ( j > 2 )
            {
                //
                // Canaux "bruit blanc"
                //
                if ( TabChannel[ j ].Freq <= SND_RATE )
                    k = 0x10000 * TabChannel[ j ].Freq / SND_RATE;
                else
                {
                    v = v * SND_RATE / TabChannel[ j ].Freq;
                    k = 0x10000;
                }
                l = TabChannel[ j ].Count;
                for( i = 0; i < SND_BUFSIZE; i++ )
                {
                    l += k;
                    if ( l & 0xFFFF0000 )
                    {
                        if ( ( NoiseGen <<= 1 ) & 0x80000000 )
                            NoiseGen ^= 0x08000001;

                        l &= 0xFFFF;
                    }
                    Wave/*[iCurrentBuffer]*/[ i ] += ( NoiseGen & 1 ? 127 : -128 ) * v;
                }
                TabChannel[ j ].Count = l;
            }
            else
                //
                // Canaux "standard"
                //
                if ( TabChannel[ j ].Freq < SND_RATE / 2 )
                {
                    k = 0x10000 * TabChannel[ j ].Freq / SND_RATE;
                    l = TabChannel[ j ].Count;
                    for ( i = 0; i < SND_BUFSIZE; i++, l += k )
                        Wave/*[iCurrentBuffer]*/[ i ] += ( l & 0x8000 ? 127 : -128 ) * v;

                    TabChannel[ j ].Count = l & 0xFFFF;
                }
    }
    
    for ( i = 0; i < SND_BUFSIZE; i++ )
    {
        //Buf[ n ][ i ] = ( UBYTE )( ( ( Wave[ i ] * SND_VOLUME ) >> 16 ) + 128 );
		//Wave[iCurrentBuffer][ i ] *= SND_VOLUME;
		//Buf[ iCurrentBuffer ][ i ] = ( USHORT )( ( ( Wave[ i ] * SND_VOLUME ) >> 16 ) + 16384 );
		//Buf[ iCurrentBuffer ][ i ] = ( USHORT )( ( ( Wave[ i ] ) >> 16 ) /*+ 16384*/ );
		//Buf[ iCurrentBuffer ][ i ] = ( TInt16 )(Wave[i]>>2);
		iCurrentPosition[i] = ( TInt16 )(Wave[i]>>2);
/*		if (Wave[i]>max)
			max=Wave[i];
		if (Wave[i]<min)
			min=Wave[i];
*/
        Wave[ i ] = 0;
    }
	
	//Write((TInt16 *)Wave[iCurrentBuffer], SND_BUFSIZE);
	Write(NULL/*(TInt16 *)Buf[iCurrentBuffer]*/, SND_BUFSIZE);
}

void CGameAudio::WaitForCopyToCompleteL()
{
	while (!iHasCopied)
		CPolledActiveScheduler::Instance()->Schedule();
}

void CGameAudio::WaitForOpenToCompleteL()
{
	TInt	count = 20;		// 5 seconds
	TInt	waitPeriod = 250 * 1000;
	while (!iIsOpen && --count)
	{
		User::After(waitPeriod);
		CPolledActiveScheduler::Instance()->Schedule();
	}
	if (!iIsOpen)
		User::LeaveIfError(KErrNotSupported);
}

void CGameAudio::MaoscOpenComplete(TInt aError)
{
//	if (aError)
//		RDebug::Print(_L("CGameAudio::MaoscOpenComplete, error=%d"), aError);

	iIsOpen = ETrue;

	TInt r;

	TInt sampleRate;
	switch (iSoundSampleRate)
	{
		case 0:
			sampleRate = TMdaAudioDataSettings::ESampleRate8000Hz;
			SND_RATE = 8000;
			break;
		case 1:
			sampleRate = TMdaAudioDataSettings::ESampleRate11025Hz;
			SND_RATE = 11025;
			break;
		case 2:
			sampleRate = TMdaAudioDataSettings::ESampleRate16000Hz;
			SND_RATE = 16000;
			break;
		case 3:
			sampleRate = TMdaAudioDataSettings::ESampleRate22050Hz;
			SND_RATE = 22050;
			break;
		case 4:
			sampleRate = TMdaAudioDataSettings::ESampleRate32000Hz;
			SND_RATE = 32000;
			break;
		case 5:
			sampleRate = TMdaAudioDataSettings::ESampleRate44100Hz;
			SND_RATE = 44100;
			break;
		case 6:
			sampleRate = TMdaAudioDataSettings::ESampleRate48000Hz;
			SND_RATE = 48000;
			break;
	}

	TRAP(r,iMdaAudioOutputStream->SetAudioPropertiesL(sampleRate, iStereo ? TMdaAudioDataSettings::EChannelsStereo : TMdaAudioDataSettings::EChannelsMono));
	if (r!=0)
		printf("prout");
	iMdaAudioOutputStream->SetVolume(iMdaAudioOutputStream->MaxVolume());        
	iMdaAudioOutputStream->SetPriority(EPriorityMuchMore, EMdaPriorityPreferenceNone);	// a voir...

	TInt	bytesPerFrame = iStereo ? iPcmFrames << 2 : iPcmFrames << 1;
	for (TInt i=0 ; i<KSoundBuffers ; i++)
	{
		iSoundBuffers[i] = HBufC8::NewL(bytesPerFrame * KBufferedFrames);
		iSoundBuffers[i]->Des().SetLength(bytesPerFrame * KBufferedFrames);
	}

	iFrameCount = 0;
	iCurrentBuffer = 0;
	iCurrentPosition = (TInt16*) iSoundBuffers[iCurrentBuffer]->Ptr();

	// ------------------------------------------------------
	//memset( iCurrentPosition, 16384, SND_BUFSIZE*2 );
	for (i=0;i<SND_BUFSIZE;i++)
		iCurrentPosition[i]=16384;

	sTheScheduler->Schedule();
	TRAP(r,iMdaAudioOutputStream->WriteL(*iSoundBuffers[iCurrentBuffer]));
	if (r!=0)
		printf("prout");
	//User::After(0);
	//WaitForCopyToCompleteL();

	if (++iCurrentBuffer == KSoundBuffers)
		iCurrentBuffer = 0;
	iCurrentPosition = (TInt16*) iSoundBuffers[iCurrentBuffer]->Ptr();
}

void CGameAudio::MaoscBufferCopied(TInt aError, const TDesC8& /*aBuffer*/)
{
	iHasCopied = ETrue;
//	if (aError)
//		RDebug::Print(_L("CGameAudio::MaoscBufferCopied, error=%d"), aError);

	PlaySound();
}

void CGameAudio::MaoscPlayComplete(TInt aError)
{
//	if (aError)
//		RDebug::Print(_L("CGameAudio::MaoscPlayComplete, error=%d"), aError);
	iHasCopied = ETrue;
}

BOOL InitSound()
{ 
    //EndSound();
    memset( TabChannel, 0, sizeof( TabChannel ) );
    NoiseGen = 1;

	sTheScheduler = CPolledActiveScheduler::NewL();

	// MR sound on/off in menu
	//if ( !Sound )
	//	return 0;

	//TMixer::iMixer.iIsStereo = ETrue;
	//TMixer::iMixer.Init();

	sGameAudio = CGameAudio::NewL(EFalse/*stereo*/, SND_BUFSIZE);
	//memset(TMixer::iMixer.iMixBuffer, 0, sizeof(TMixer::iMixer.iMixBuffer));

	return 1;
}

/********************************************************* !NAME! **************
* Nom : Sound
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Modifie la frquence/volume d'un canal
*
* Rsultat    : /
*
* Variables globales modifies : TabChannel
*
********************************************************** !0! ****************/
void SetSound( int Channel, int Freq, int Volume )
{
    TabChannel[ Channel ].Freq = Freq;
    TabChannel[ Channel ].Volume = Volume;
}

void gniPlaySound()
{
	//CPolledActiveScheduler::Instance()->Schedule();
	sTheScheduler->Schedule();
}

#endif	// USE_SOUND