
#include <stdio.h>
#include <unistd.h>
#include <e32std.h>
#include <f32file.h>
#include <e32svr.h>
#include <estlib.h>
#include <eikdll.h>
#include <w32std.h>
#include <hal.h>
#include <eikenv.h>

#include "game.h"


void DumpMemInfo()
{
	TInt	ramSize, ramSizeFree, romSize;
	
	HAL::Get(HALData::EMemoryRAM, ramSize);
	HAL::Get(HALData::EMemoryRAMFree, ramSizeFree);
	HAL::Get(HALData::EMemoryROM, romSize);

//	RDebug::Print(_L("ram=%dKB, ram_free=%dKB, rom=%dKB"), ramSize/1024, ramSizeFree/1024, romSize/1024);	
}




extern "C"
{

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <math.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <stdarg.h>
#include <ctype.h>

void CPCMain(void);
void CPCMainL() 
{
	CPCMain();
}


unsigned long GetTickCount();
void Sleep(long time);
}

unsigned long GetTickCount()
{
	TTime univTime;
	static TTime startTime;
	static char init=0;

	if (!init)
	{	startTime.UniversalTime();
		init=1;
	}

	univTime.UniversalTime();

	TTimeIntervalMicroSeconds	iInterval;
	iInterval = univTime.MicroSecondsFrom(startTime);

	TInt64 iInterval64 = iInterval.Int64()/TInt64(1000);

	//return (unsigned long)(iInterval.Int64().GetTReal()/1000.0);
	//return iInterval64.GetTInt();
	return iInterval.Int64().GetTInt();
}

void Sleep(long time)
{
	if (time>0)
		User::After(TTimeIntervalMicroSeconds32(time /** 1000*/));
}

int VID_SetMode(int modenum);
void VID_SetPalette ();
void ReadConfig();
int CPCL(int argc, char** argv) 
{ 
	//myargc = argc; 
	//myargv = argv; 

	DumpMemInfo();

	VID_SetMode(0);
	VID_SetPalette();

	ReadConfig();
	
	TRAPD(err, CPCMainL());

	return err;
} 

void CPCDebugPrint(const char* format, ...)
{
	TBuf<128>	buf;
	char	text[128];
	va_list     argptr;

	va_start(argptr, format);
	vsprintf(text, format, argptr);
	va_end(argptr);

	TPtrC8	ptr((TText8*) text);
	buf.Copy(ptr);
//	RDebug::Print(_L("%S"), &buf);
}


void EpocGameL(int argc, char* argv[])
{
#ifdef __WINS__
	int crt_argc=0;
	char** crt_argv=0;
	char** crt_envp=0;

	__crt0(crt_argc, crt_argv, crt_envp);
#endif
	
	printf(" ");
	fflush(stdout);	// MR

#ifdef __WINS__
	chdir("z:\\system\\apps\\S60cpc");	// MR
#else
	chdir("e:\\system\\apps\\S60cpc");	// MR
#endif

	CPCL(argc, argv);

#ifdef __WINS__
	RThread	me;
#else
	RProcess	me;
	me.Terminate(0);
#endif

#ifdef __WINS__
// MR
/*	fclose(stdin);
	fclose(stdout);
	fclose(stderr);*/
#endif
}

void TargetEpocGameL(int argc, char* argv[])
{
	EpocGameL(argc, argv);
}


int TargetGame(int argc, char* argv[])
{
	CTrapCleanup* cleanup=CTrapCleanup::New();

	TRAPD(error, TargetEpocGameL(argc, argv));

	__ASSERT_ALWAYS(!error, User::Panic(_L("S60CPC"), error));

	delete cleanup;

	return 0;
}

static char* argv[] = {"", ""};

#ifdef __WINS__
EXPORT_C TInt WinsMain()
#else
GLDEF_C TInt E32Main()
#endif
{
	TargetGame(0, argv);

	return 0;
}


#ifdef __WINS__
int __cdecl E32Dll(TDllReason aReason)
{
	return(KErrNone);
}
#endif
