/*******************************************************************
 *
 *	File:		Navigation.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2002, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __NAVIGATION_H
#define __NAVIGATION_H

#include <e32keys.h>
//#include <quartzkeys.h>	// MR

#ifndef EQuartzKeyBack
#define EQuartzKeyBack EKeyDevice3	
#endif

#ifndef EQuartzKeyMenu2
#define EQuartzKeyMenu2 EKeyDevice9
#endif

typedef struct 
{
	TInt	iPhysicalKey;
	TInt	iGameKey;
} TGameKeyCodeTable;

typedef struct 
{
	TInt	iPhysicalScanCode;
	TInt	iGameScanCode;
} TGameScanCodeTable;


/**********************************************
 *
 * Game key section
 *
 * All key events sent out use these scan 
 * and key codes
 *
 **********************************/

#ifdef PROJECT_S60CPC

#define GAME_LEFT_SCANCODE			251
#define GAME_RIGHT_SCANCODE			252
#define GAME_UP_SCANCODE			253
#define GAME_DOWN_SCANCODE			254
#define GAME_BUTTON1_SCANCODE		254
#define GAME_BUTTON2_SCANCODE		255

#else

#define GAME_LEFT_SCANCODE			10
#define GAME_RIGHT_SCANCODE			11
#define GAME_UP_SCANCODE			12
#define GAME_DOWN_SCANCODE			13
#define GAME_BUTTON1_SCANCODE		14
#define GAME_BUTTON2_SCANCODE		15

#endif

#define GAME_LEFT_KEYCODE			GAME_LEFT_SCANCODE
#define GAME_RIGHT_KEYCODE			GAME_RIGHT_SCANCODE
#define GAME_UP_KEYCODE				GAME_UP_SCANCODE
#define GAME_DOWN_KEYCODE			GAME_DOWN_SCANCODE
#define GAME_BUTTON1_KEYCODE		GAME_BUTTON1_SCANCODE
#define GAME_BUTTON2_KEYCODE		GAME_BUTTON2_SCANCODE


/*
 * Define the scan codes and key codes used for navigation
 * on this device.
 */

#if 0	// MR
/**********************************
 *
 * P800 physical key section
 *
 **********************************/

#define DEVICE_LEFT_SCANCODE		EStdKeyDeviceE
#define DEVICE_RIGHT_SCANCODE		EStdKeyDeviceD
#define DEVICE_UP_SCANCODE			EStdKeyDevice1
#define DEVICE_DOWN_SCANCODE		EStdKeyDevice2
#define DEVICE_SELECT_SCANCODE		EStdKeyDevice8
#define DEVICE_ESC_SCANCODE			EStdKeyDevice0

#define DEVICE_LEFT_KEYCODE			EQuartzKeyBack
#define DEVICE_RIGHT_KEYCODE		EQuartzKeyMenu2
#define DEVICE_UP_KEYCODE			EQuartzKeyTwoWayUp
#define DEVICE_DOWN_KEYCODE			EQuartzKeyTwoWayDown
#define DEVICE_SELECT_KEYCODE		EQuartzKeyConfirm
#define DEVICE_ESC_KEYCODE			EKeyDevice0

#else	// MR

#define DEVICE_LEFT_SCANCODE		EStdKeyLeftArrow
#define DEVICE_RIGHT_SCANCODE		EStdKeyRightArrow
#define DEVICE_UP_SCANCODE			EStdKeyUpArrow
#define DEVICE_DOWN_SCANCODE		EStdKeyDownArrow
//#define DEVICE_SELECT_SCANCODE		EStdKeyDevice8
#define DEVICE_SELECT_SCANCODE		EStdKeyDevice3
#define DEVICE_ESC_SCANCODE			EStdKeyDevice0

#define DEVICE_LEFT_KEYCODE			EKeyLeftArrow
#define DEVICE_RIGHT_KEYCODE		EKeyRightArrow
#define DEVICE_UP_KEYCODE			EKeyUpArrow
#define DEVICE_DOWN_KEYCODE			EKeyDownArrow
#define DEVICE_SELECT_KEYCODE		EKeyDevice3
#define DEVICE_ESC_KEYCODE			EKeyDevice0

#endif	// MR

#endif			/* __NAVIGATION_H */


